#ifndef _ADT10_H
#define _ADT10_H

/*{{{  includes */

#include <stdlib.h>
#include <string.h>
#include <aterm1.h>
#include "ADT10_dict.h"

/*}}}  */

/*{{{  prologue */


/*}}}  */
/*{{{  typedefs */

typedef struct _ADT10_Entries *ADT10_Entries;
typedef struct _ADT10_Entry *ADT10_Entry;

/*}}}  */

void ADT10_initADT10Api(void);

/*{{{  protect functions */

void ADT10_protectEntries(ADT10_Entries *arg);
void ADT10_protectEntry(ADT10_Entry *arg);

/*}}}  */
/*{{{  term conversion functions */

ADT10_Entries ADT10_EntriesFromTerm(ATerm t);
ATerm ADT10_EntriesToTerm(ADT10_Entries arg);
ADT10_Entry ADT10_EntryFromTerm(ATerm t);
ATerm ADT10_EntryToTerm(ADT10_Entry arg);

/*}}}  */
/*{{{  list functions */


/*}}}  */
/*{{{  constructors */

ADT10_Entries ADT10_makeEntriesEmpty(void);
ADT10_Entries ADT10_makeEntriesList(ADT10_Entry head, ADT10_Entries tail);
ADT10_Entry ADT10_makeEntryConstructor(ATerm sort, ATerm alternative, ATerm termPattern);

/*}}}  */
/*{{{  equality functions */

ATbool ADT10_isEqualEntries(ADT10_Entries arg0, ADT10_Entries arg1);
ATbool ADT10_isEqualEntry(ADT10_Entry arg0, ADT10_Entry arg1);

/*}}}  */
/*{{{  ADT10_Entries accessors */

ATbool ADT10_isValidEntries(ADT10_Entries arg);
inline ATbool ADT10_isEntriesEmpty(ADT10_Entries arg);
inline ATbool ADT10_isEntriesList(ADT10_Entries arg);
ATbool ADT10_hasEntriesHead(ADT10_Entries arg);
ATbool ADT10_hasEntriesTail(ADT10_Entries arg);
ADT10_Entry ADT10_getEntriesHead(ADT10_Entries arg);
ADT10_Entries ADT10_getEntriesTail(ADT10_Entries arg);
ADT10_Entries ADT10_setEntriesHead(ADT10_Entries arg, ADT10_Entry head);
ADT10_Entries ADT10_setEntriesTail(ADT10_Entries arg, ADT10_Entries tail);

/*}}}  */
/*{{{  ADT10_Entry accessors */

ATbool ADT10_isValidEntry(ADT10_Entry arg);
inline ATbool ADT10_isEntryConstructor(ADT10_Entry arg);
ATbool ADT10_hasEntrySort(ADT10_Entry arg);
ATbool ADT10_hasEntryAlternative(ADT10_Entry arg);
ATbool ADT10_hasEntryTermPattern(ADT10_Entry arg);
ATerm ADT10_getEntrySort(ADT10_Entry arg);
ATerm ADT10_getEntryAlternative(ADT10_Entry arg);
ATerm ADT10_getEntryTermPattern(ADT10_Entry arg);
ADT10_Entry ADT10_setEntrySort(ADT10_Entry arg, ATerm sort);
ADT10_Entry ADT10_setEntryAlternative(ADT10_Entry arg, ATerm alternative);
ADT10_Entry ADT10_setEntryTermPattern(ADT10_Entry arg, ATerm termPattern);

/*}}}  */
/*{{{  sort visitors */

ADT10_Entries ADT10_visitEntries(ADT10_Entries arg, ADT10_Entry (*acceptHead)(ADT10_Entry));
ADT10_Entry ADT10_visitEntry(ADT10_Entry arg, ATerm (*acceptSort)(ATerm), ATerm (*acceptAlternative)(ATerm), ATerm (*acceptTermPattern)(ATerm));

/*}}}  */

#endif /* _ADT10_H */
